#ifndef __Ax_Vdr_MenuHelpKeys_H__
#define __Ax_Vdr_MenuHelpKeys_H__
//=============================================================================
/*
 * See the file README in the main directory for a description of
 * this software, copyright information, and how to reach the author.
 *
 * Author: alex
 * Date:   16.09.2004
 *
 * Last modfied:
 *   $Author: alex $
 *   $Date: 2013-03-20 19:53:42 +0100 (Mi, 20 Mär 2013) $
 */
//=============================================================================

//=============================================================================
//     includes
//=============================================================================

//----- qt --------------------------------------------------------------------
//----- CORBA -----------------------------------------------------------------
//----- C++ -------------------------------------------------------------------
//----- C ---------------------------------------------------------------------
//----- Vdr -------------------------------------------------------------------
#include <vdr/osd.h>
#include <vdr/menuitems.h>
#include <vdr/font.h>

//----- AxLib -----------------------------------------------------------------
#include <Ax/Vdr/OsdMenu.h>

//----- local -----------------------------------------------------------------

//=============================================================================
//     forward declarations
//=============================================================================

//=============================================================================
//     namespaces
//=============================================================================
namespace Ax  {
namespace Vdr {

//=============================================================================
//     forward declarations
//=============================================================================
class Action;

//=============================================================================
//     class MenuHelpKeys
//============================================================================
/** Menu to show the key-mappings for a given OsdMenu.
*/
template <typename TT>
class MenuHelpKeys : public Ax::Vdr::OsdMenu
{
    //-------------------------------------------------------------------------
    //     typedefs
    //-------------------------------------------------------------------------
    typedef Ax::Vdr::OsdMenu PARENT;
    typedef MenuHelpKeys     MYSELF;

  protected:
    //-------------------------------------------------------------------------
    //     enums
    //-------------------------------------------------------------------------
    enum AxEAction
    {
      A_FIRST          = PARENT::A_LAST
    , A_ACTIVATE_KEY   = A_FIRST
    , A_LAST
    };

  public:
    //-------------------------------------------------------------------------
    //     MenuHelpKeys()
    //-------------------------------------------------------------------------
    MenuHelpKeys(const Ax::Vdr::OsdMenuBase<TT> *theDocuMenu);

    //-------------------------------------------------------------------------
    //     ~MenuHelpKeys()
    //-------------------------------------------------------------------------
    virtual ~MenuHelpKeys();

    //-------------------------------------------------------------------------
    //     processAction()
    //-------------------------------------------------------------------------
    virtual eOSState processAction(const Ax::Vdr::Action &theAction, eOSState = osUnknown);

  private:
    //-------------------------------------------------------------------------
    //     attributes
    //-------------------------------------------------------------------------
    const Ax::Vdr::OsdMenuBase<TT> *myDocuMenu;

}; // class MenuHelpKeys

//=============================================================================
//     namespaces
//=============================================================================
} // Vdr
} // Ax

//=============================================================================
//     read the implementation of the template class
//=============================================================================
#include <Ax/Vdr/MenuHelpKeys.cpp>

#endif
